import discord
import asyncio
import logging
import os
from bot.selfbot import SelfBot
from config import TOKEN

def main():
    # Configure logging
    logging.basicConfig(
        level=logging.INFO,
        format='%(asctime)s - %(name)s - %(levelname)s - %(message)s'
    )
    
    # Set up Discord client
    intents = discord.Intents.all()
    
    # Create the selfbot
    client = SelfBot(intents=intents)
    
    # Run the bot
    client.run(TOKEN)

if __name__ == "__main__":
    main()
